.bios
.page 2
.rom
.start DEBUT

NAMTBL equ 1800h
SPRTBL equ 3800h
SPRATR equ 1b00h

DEBUT:
call DISSCR
ld hl,0f3e9h
ld [hl],15
inc hl
ld [hl],0
inc hl
ld [hl],0
call INIGRP
ld bc,06201h
call WRTVDP

ld hl,NAMTBL
ld bc,768
xor a
call FILVRM

ld hl,ATR_INITIAL
ld de,SPRITES
ld bc,8
ldir

call ENASCR

LOOP:
ld hl,SPR_NEM
call CHOIX_SPRITE
ld a,8
ld [SPRITES+7],a


xor a
call GTSTCK
ld b,a

cp 1
CALL z,NORTH
ld a,b

cp 2
CALL z,NORTHEAST
ld a,b

cp 3
CALL z,EAST
ld a,b

cp 4
CALL z,SOUTHEAST
ld a,b

cp 5
CALL z,SOUTH
ld a,b

cp 6
CALL z,SOUTHWEST
ld a,b

cp 7
CALL z,WEST
ld a,b

cp 8
CALL z,NORTHWEST


call DUMP
jp LOOP

EAST:
ld a,[SPRITES+1]
cp 240
jr z,@@STOP
ld a,[SPRITES+1]
inc a
inc a
ld [SPRITES+1],a
ld a,[SPRITES+5]
inc a
inc a
ld [SPRITES+5],a
@@STOP:
nop
ret

WEST:
ld a,[SPRITES+1]
cp 0
jr z,@@STOP
ld a,[SPRITES+1]
dec a
dec a
ld [SPRITES+1],a
ld a,[SPRITES+5]
dec a
dec a
ld [SPRITES+5],a
@@STOP:
nop
ret

NORTH:
ld hl,SPR_UP
call CHOIX_SPRITE
ld a,4
ld [SPRITES+7],a
ld a,[SPRITES]
cp 0
jr z,@@STOP 
ld a,[SPRITES]
dec a
dec a
ld [SPRITES],a
ld a,[SPRITES+4]
dec a
dec a
ld [SPRITES+4],a
@@STOP:
nop
ret

SOUTH:
ld hl,SPR_DOWN
call CHOIX_SPRITE
ld a,[SPRITES]
cp 176
jr z,@@STOP
ld a,[SPRITES]
inc a
inc a
ld [SPRITES],a
ld a,[SPRITES+4]
inc a
inc a
ld [SPRITES+4],a
@@STOP:
nop
ret

NORTHEAST:
call NORTH
call EAST
ret

NORTHWEST:
call NORTH
call WEST
ret

SOUTHEAST:
call SOUTH
call EAST
ret

SOUTHWEST:
call SOUTH
call WEST
ret

DUMP:
halt
ld hl,SPRITES
ld de,SPRATR
ld bc,8
call LDIRVM
ret

CHOIX_SPRITE:
ld de,SPRTBL
ld bc,64
call LDIRVM
ret

ATR_INITIAL:
	db 88,120,0,15
	db 88,120,4,8


SPR_NEM:
    db  000h,080h,0e0h,070h,07fh,07fh,0bfh,0bfh,0bfh,078h,0e0h,000h,000h,000h,000h,000h
    db  000h,000h,000h,000h,000h,088h,0ffh,0f8h,000h,000h,000h,000h,000h,000h,000h,000h
    db  000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
    db  000h,000h,000h,000h,0c0h,070h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h

SPR_UP:
    db 000h,080h,0e0h,070h,0ffh,01fh,001h,000h,000h,000h,000h,000h,000h,000h,000h,000h
    db 000h,000h,000h,000h,080h,0f0h,0ffh,000h,000h,000h,000h,000h,000h,000h,000h,000h
    db 000h,000h,000h,000h,000h,0e0h,0feh,07fh,03fh,01eh,018h,000h,000h,000h,000h,000h
    db 000h,000h,000h,000h,000h,000h,000h,0fch,0f0h,000h,000h,000h,000h,000h,000h,000h

SPR_DOWN:
    db 000h,000h,0b0h,0fch,07fh,07fh,0bfh,0bfh,0bfh,07fh,078h,0e0h,000h,000h,000h,000h
    db 000h,000h,000h,000h,080h,018h,08fh,0fch,0e0h,000h,000h,000h,000h,000h,000h,000h
    db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
    db 000h,000h,000h,000h,000h,0e0h,070h,000h,000h,000h,000h,000h,000h,000h,000h,000h

.page 3

SPRITES:
ds 8